/*==============================================================================*/
/*  Copyright (C) 2020, Heartland Data inc. All Rights Reserved.                */
/*                                                                              */
/*  Title  :   DataWriting Coverage Driver                                      */
/*  AppVer :   DT+ Ver1.00`                                                    */
/*  FileID :   23c1                                                             */
/*  Version:   1.0                                                              */
/*  Author :   HLDC                                                             */
/*==============================================================================*/
#include <stdio.h>
#include "DTTestPointCountDefine.h"
/*==============================================================================*/
/*  Please customize the code for your environment.                             */
/*==============================================================================*/
#ifdef __cplusplus
extern "C" {
	void _TP_BusOutBuf(unsigned int dat);
	void _TP_SaveCoverageData(void);
}
#endif
/*==============================================================================*/
/*  Don't change the code from here as possible.                                */
/*==============================================================================*/
#define MAX_LOG_BIT_SIZE	((__DTTESTPoint_TotalCount + 7) / 8)
static unsigned char logBitBuf[MAX_LOG_BIT_SIZE];
static unsigned int bufPos = 0;

/*==============================================================================*/
/*  Func: _TP_BusOut                                                            */
/*  Desc: Called by Test Point                                                  */
/*==============================================================================*/
void _TP_BusOutBuf( unsigned int dat )
{
	logBitBuf[dat/8] |= 1 << (dat & 7);
}

/*==============================================================================*/
/*  Func: _TP_SaveCoverageData                                                  */
/*  Desc: Save Coverage Data Buffer to file.                                    */
/*        to be called when want to save data                                   */
/*==============================================================================*/
void _TP_SaveCoverageData(void)
{
	FILE *dat_file;
	int i;
	unsigned char buff[8];

	if (fopen_s(&dat_file, "CoverageData.dat", "wb+") != 0)
	{
		return;
	}

	bufPos = 0;
	while (bufPos < MAX_LOG_BIT_SIZE) {
		for (i = 0; i < 8; i++) {
			if (bufPos < MAX_LOG_BIT_SIZE) {
				buff[i] = logBitBuf[bufPos++];
			} else {
				buff[i] = 0;
			}
		}
		fwrite(buff, sizeof(char), 8, dat_file);
	}
	fclose(dat_file);
}
/*==============================================================================*/

